#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Odds2_Profit.h"
std::auto_ptr<Odds2_Profit> Odds2_Profit::msSingleton(nullptr);

int Odds2_Profit::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_ProfitData* Odds2_Profit::GetData(int Profit)
{
	auto it = mMapData.find(Profit);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Odds2_ProfitData>& Odds2_Profit::GetMapData()
{
	return mMapData;
}

void Odds2_Profit::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Odds2_Profit.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_ProfitData data;
		data.mProfit = element->IntAttribute("Profit");
		data.mRandLower = element->IntAttribute("RandLower");
		data.mRandUpper = element->IntAttribute("RandUpper");
		if (mMapData.find(data.mProfit) != mMapData.end())std::cout <<"data refind:" << data.mProfit << std::endl;
		CCASSERT(mMapData.find(data.mProfit) == mMapData.end(), "data.mProfit is exists");
		mMapData.insert(std::make_pair(data.mProfit, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Odds2_Profit Loaded. Load Data:%u", mMapData.size());
}

void Odds2_Profit::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Odds2_Profit");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Odds2_Profit");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Odds2_ProfitData data;
		LuaCfgHelper::readInt(L, "Profit", data.mProfit);
		LuaCfgHelper::readInt(L, "RandLower", data.mRandLower);
		LuaCfgHelper::readInt(L, "RandUpper", data.mRandUpper);
		if (mMapData.find(data.mProfit) != mMapData.end())std::cout <<"data refind:" << data.mProfit << std::endl;
		CCASSERT(mMapData.find(data.mProfit) == mMapData.end(), "data.mProfit is exists");
		mMapData.insert(std::make_pair(data.mProfit, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Odds2_Profit Loaded. Load Data:%u", mMapData.size());
}

void Odds2_Profit::Reload()
{
	mMapData.clear();
	Load();
}

Odds2_Profit* Odds2_Profit::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_Profit());
	}
	return msSingleton.get();
}

void Odds2_Profit::Release()
{
	msSingleton.reset(nullptr);
}
